// BALIVE LIMITED PROPRIETARY INFORMATION //
// This software is supplied under the terms of a license agreement or
// nondisclosure agreement with B-Alive GmbH and may not 
// be copied or disclosed except in accordance with the terms of that 
// agreement.
//
//      Copyright (c) 2008 B-Alive GmbH.
//      All Rights Reserved.
//
// B-Alive GmbH
// http://www.b-alive.de
//
// author: ank
// modifier: mad

#include <ShaderFragments.hlsl>

const float3    SUN_LIGHT_DIRECTION_WS : GLOBAL;
const float4    SUN_LIGHT_AMBIENT : GLOBAL;
const float4    SUN_LIGHT_DIFFUSE : GLOBAL;
// const float3 SUN_LIGHT_SPECULAR : GLOBAL;
const float4    GROUND_BLEND_COLOR_MIN : GLOBAL;
const float4    GROUND_BLEND_COLOR_MAX : GLOBAL;

const float3    CAMERA_POS_WS : GLOBAL;

// ================================================================================================
// blend maps
// ================================================================================================
DECL_BLEND_SAMPLER(BlendMap00, TextureBlendMap00, MIN_FILTERTYPE, MAG_FILTERTYPE, MIP_FILTERTYPE, MAX_ANISOTROPY)
DECL_BLEND_SAMPLER(BlendMap01, TextureBlendMap01, MIN_FILTERTYPE, MAG_FILTERTYPE, MIP_FILTERTYPE, MAX_ANISOTROPY)
DECL_BLEND_SAMPLER(BlendMap02, TextureBlendMap02, MIN_FILTERTYPE, MAG_FILTERTYPE, MIP_FILTERTYPE, MAX_ANISOTROPY)
DECL_BLEND_SAMPLER(BlendMap03, TextureBlendMap03, MIN_FILTERTYPE, MAG_FILTERTYPE, MIP_FILTERTYPE, MAX_ANISOTROPY)
DECL_BLEND_SAMPLER(BlendMap04, TextureBlendMap04, MIN_FILTERTYPE, MAG_FILTERTYPE, MIP_FILTERTYPE, MAX_ANISOTROPY)
DECL_BLEND_SAMPLER(BlendMap05, TextureBlendMap05, MIN_FILTERTYPE, MAG_FILTERTYPE, MIP_FILTERTYPE, MAX_ANISOTROPY)
DECL_BLEND_SAMPLER(BlendMap06, TextureBlendMap06, MIN_FILTERTYPE, MAG_FILTERTYPE, MIP_FILTERTYPE, MAX_ANISOTROPY)
DECL_BLEND_SAMPLER(BlendMap07, TextureBlendMap07, MIN_FILTERTYPE, MAG_FILTERTYPE, MIP_FILTERTYPE, MAX_ANISOTROPY)
DECL_BLEND_SAMPLER(BlendMap08, TextureBlendMap08, MIN_FILTERTYPE, MAG_FILTERTYPE, MIP_FILTERTYPE, MAX_ANISOTROPY)
DECL_BLEND_SAMPLER(BlendMap09, TextureBlendMap09, MIN_FILTERTYPE, MAG_FILTERTYPE, MIP_FILTERTYPE, MAX_ANISOTROPY)

DECL_BLEND_SAMPLER(BlendMapSnow, TextureBlendSnow, MIN_FILTERTYPE, MAG_FILTERTYPE, MIP_FILTERTYPE, MAX_ANISOTROPY)

// ================================================================================================
// texture maps
// ================================================================================================
DECL_SAMPLER(Surface00, TextureSurface00, MIN_FILTERTYPE, MAG_FILTERTYPE, MIP_FILTERTYPE, MAX_ANISOTROPY)
DECL_SAMPLER(Surface01, TextureSurface01, MIN_FILTERTYPE, MAG_FILTERTYPE, MIP_FILTERTYPE, MAX_ANISOTROPY)
DECL_SAMPLER(Surface02, TextureSurface02, MIN_FILTERTYPE, MAG_FILTERTYPE, MIP_FILTERTYPE, MAX_ANISOTROPY)
DECL_SAMPLER(Surface03, TextureSurface03, MIN_FILTERTYPE, MAG_FILTERTYPE, MIP_FILTERTYPE, MAX_ANISOTROPY)
DECL_SAMPLER(Surface04, TextureSurface04, MIN_FILTERTYPE, MAG_FILTERTYPE, MIP_FILTERTYPE, MAX_ANISOTROPY)
DECL_SAMPLER(Surface05, TextureSurface05, MIN_FILTERTYPE, MAG_FILTERTYPE, MIP_FILTERTYPE, MAX_ANISOTROPY)
DECL_SAMPLER(Surface06, TextureSurface06, MIN_FILTERTYPE, MAG_FILTERTYPE, MIP_FILTERTYPE, MAX_ANISOTROPY)
DECL_SAMPLER(Surface07, TextureSurface07, MIN_FILTERTYPE, MAG_FILTERTYPE, MIP_FILTERTYPE, MAX_ANISOTROPY)
DECL_SAMPLER(Surface08, TextureSurface08, MIN_FILTERTYPE, MAG_FILTERTYPE, MIP_FILTERTYPE, MAX_ANISOTROPY)
DECL_SAMPLER(Surface09, TextureSurface09, MIN_FILTERTYPE, MAG_FILTERTYPE, MIP_FILTERTYPE, MAX_ANISOTROPY)
DECL_SAMPLER(Surface10, TextureSurface10, MIN_FILTERTYPE, MAG_FILTERTYPE, MIP_FILTERTYPE, MAX_ANISOTROPY)
DECL_SAMPLER(Surface11, TextureSurface11, MIN_FILTERTYPE, MAG_FILTERTYPE, MIP_FILTERTYPE, MAX_ANISOTROPY)
DECL_SAMPLER(Surface12, TextureSurface12, MIN_FILTERTYPE, MAG_FILTERTYPE, MIP_FILTERTYPE, MAX_ANISOTROPY)
DECL_SAMPLER(Surface13, TextureSurface13, MIN_FILTERTYPE, MAG_FILTERTYPE, MIP_FILTERTYPE, MAX_ANISOTROPY)
DECL_SAMPLER(Surface14, TextureSurface14, MIN_FILTERTYPE, MAG_FILTERTYPE, MIP_FILTERTYPE, MAX_ANISOTROPY)
DECL_SAMPLER(Surface15, TextureSurface15, MIN_FILTERTYPE, MAG_FILTERTYPE, MIP_FILTERTYPE, MAX_ANISOTROPY)
DECL_SAMPLER(Surface16, TextureSurface16, MIN_FILTERTYPE, MAG_FILTERTYPE, MIP_FILTERTYPE, MAX_ANISOTROPY)
DECL_SAMPLER(Surface17, TextureSurface17, MIN_FILTERTYPE, MAG_FILTERTYPE, MIP_FILTERTYPE, MAX_ANISOTROPY)
DECL_SAMPLER(Surface18, TextureSurface18, MIN_FILTERTYPE, MAG_FILTERTYPE, MIP_FILTERTYPE, MAX_ANISOTROPY)
DECL_SAMPLER(Surface19, TextureSurface19, MIN_FILTERTYPE, MAG_FILTERTYPE, MIP_FILTERTYPE, MAX_ANISOTROPY)
DECL_SAMPLER(Surface20, TextureSurface20, MIN_FILTERTYPE, MAG_FILTERTYPE, MIP_FILTERTYPE, MAX_ANISOTROPY)
DECL_SAMPLER(Surface21, TextureSurface21, MIN_FILTERTYPE, MAG_FILTERTYPE, MIP_FILTERTYPE, MAX_ANISOTROPY)
DECL_SAMPLER(Surface22, TextureSurface22, MIN_FILTERTYPE, MAG_FILTERTYPE, MIP_FILTERTYPE, MAX_ANISOTROPY)
DECL_SAMPLER(Surface23, TextureSurface23, MIN_FILTERTYPE, MAG_FILTERTYPE, MIP_FILTERTYPE, MAX_ANISOTROPY)
DECL_SAMPLER(Surface24, TextureSurface24, MIN_FILTERTYPE, MAG_FILTERTYPE, MIP_FILTERTYPE, MAX_ANISOTROPY)
DECL_SAMPLER(Surface25, TextureSurface25, MIN_FILTERTYPE, MAG_FILTERTYPE, MIP_FILTERTYPE, MAX_ANISOTROPY)
DECL_SAMPLER(Surface26, TextureSurface26, MIN_FILTERTYPE, MAG_FILTERTYPE, MIP_FILTERTYPE, MAX_ANISOTROPY)
DECL_SAMPLER(Surface27, TextureSurface27, MIN_FILTERTYPE, MAG_FILTERTYPE, MIP_FILTERTYPE, MAX_ANISOTROPY)
DECL_SAMPLER(Surface28, TextureSurface28, MIN_FILTERTYPE, MAG_FILTERTYPE, MIP_FILTERTYPE, MAX_ANISOTROPY)
DECL_SAMPLER(Surface29, TextureSurface29, MIN_FILTERTYPE, MAG_FILTERTYPE, MIP_FILTERTYPE, MAX_ANISOTROPY)

DECL_SAMPLER(Snow, TextureSnow, MIN_FILTERTYPE, MAG_FILTERTYPE, MIP_FILTERTYPE, MAX_ANISOTROPY)



// ================================================================================================
struct VSIn
{
   float3 Pos					: POSITION;
   float3 Normal				: NORMAL;
   float4 TexBlendNCWeight		: COLOR0;
   float2 TexSurface			: TEXCOORD0;
};

// ================================================================================================
struct VSOut
{
	float4 Pos				: POSITION;
	float4 Color			: COLOR;
	float4 Fog				: COLOR1;
	float2 TexBlend			: TEXCOORD0;	// Blendmap
	float2 TexMaterial00 	: TEXCOORD1;	// Material 3 * Stage
	float2 TexMaterial01	: TEXCOORD2;	// Material (3 * Stage) + 1
	float2 TexMaterial02	: TEXCOORD3;	// Material (3 * Stage) + 2 
};

// ================================================================================================
struct PSIn
{
	float4 Color 			: COLOR;
	float4 Fog				: COLOR1;
	float2 TexBlend			: TEXCOORD0;
	float2 TexMaterial00 	: TEXCOORD1;
	float2 TexMaterial01	: TEXCOORD2;
	float2 TexMaterial02	: TEXCOORD3;
};



// ================================================================================================
VSOut VSDebug( VSIn i_VSIn )
{
	VSOut Out = (VSOut) 0; 
	
	// Output transformed vertex position:
	Out.Pos = mul(float4( i_VSIn.Pos, 1.0f ), matWorldViewProjection); 
	
	Out.Color = 1.0f;
	
	// Propagate texture coordinates:
	Out.TexBlend = i_VSIn.TexBlendNCWeight.xy;
	
	Out.TexMaterial00 = i_VSIn.TexSurface;
	Out.TexMaterial01 = i_VSIn.TexSurface;
	Out.TexMaterial02 = i_VSIn.TexSurface;
	
	return Out;
}

// ================================================================================================
float4 PSDebug( PSIn i_PSIn ) : COLOR
{
	return i_PSIn.Color;
}



// ================================================================================================
float ComputeFogValue( float3 i_PosWS )
{
//	float CamDist = length( i_PosWS - CAMERA_POS_WS );
 	float CamDist = i_PosWS.z;

	/////////////////////////////////////////////////////////////////////
	// fog computation linear or exp
	
	float NearD = FogStart;
	float FarD = FogEnd;
	float FadeRange = FarD - NearD;
	
	// linear fog version
	
	// comment in this line to apply linear fog
	return 1.0f - min( 1.0f, max( 0.0f, ( FarD - CamDist ) / FadeRange ) );
	
	// exp fog version	
	//float eTPODTD = exp( CamDist * FogDensity.x );
	
	//return 1.0f - (1.0f / eTPODTD);
	
	/////////////////////////////////////////////////////////////////////
	
}



// ================================================================================================
VSOut VSTransformEnlightenGernerateUV( VSIn i_VSIn )
{
	VSOut Out = (VSOut) 0; 
	
	// Output transformed vertex position:
	Out.Pos = mul(float4(i_VSIn.Pos, 1.0f), matWorldViewProjection); 
//	Out.Fog = ComputeFogValue( i_VSIn.Pos );
	Out.Fog = ComputeFogValue( Out.Pos.xyz );
	
	float3 LightDirOS = normalize(mul(SUN_LIGHT_DIRECTION_WS, matInverseWorld));
	float3 A = SUN_LIGHT_AMBIENT;
	float3 D = SUN_LIGHT_DIFFUSE;
	
	Out.Color.xyz = EnlightenAD( i_VSIn.Pos, i_VSIn.Normal, LightDirOS, A, D );
	Out.Color *= lerp( GROUND_BLEND_COLOR_MIN, GROUND_BLEND_COLOR_MAX, i_VSIn.TexBlendNCWeight.z );
	Out.Color.w = 1.0f;
	
	// Propagate texture coordinates:
	Out.TexBlend = i_VSIn.TexBlendNCWeight.xy;
	
	Out.TexMaterial00 = i_VSIn.TexSurface;
	Out.TexMaterial01 = i_VSIn.TexSurface;
	Out.TexMaterial02 = i_VSIn.TexSurface;

	// Out.Fog = Out.Pos.z / Out.Pos.w;

	return Out;
}

// ================================================================================================
float4 PSBlendMaterialsSolidSet( PSIn i_PSIn ) : COLOR
{
	float4 Weights = tex2D( BlendMap00, i_PSIn.TexBlend );
	float4 ColorMaterial00 = tex2D( Surface00, i_PSIn.TexMaterial00 );
	float4 ColorMaterial01 = tex2D( Surface01, i_PSIn.TexMaterial01 );
	float4 ColorMaterial02 = tex2D( Surface02, i_PSIn.TexMaterial02 );
		
	float4 Color = (	ColorMaterial00 * Weights.x +
						ColorMaterial01 * Weights.y +
						ColorMaterial02 * Weights.z ) * i_PSIn.Color;
	
	// float4 Color = float4( 0.0f, 1.0f, 0.0f, 1.0f );
	
	return Color;//* Weights.w;
}

// ================================================================================================
float4 PSBlendMaterialsBlendSet01( PSIn i_PSIn ) : COLOR
{
	float4 Weights = tex2D( BlendMap01, i_PSIn.TexBlend );
	float4 ColorMaterial00 = tex2D( Surface03, i_PSIn.TexMaterial00 );
	float4 ColorMaterial01 = tex2D( Surface04, i_PSIn.TexMaterial01 );
	float4 ColorMaterial02 = tex2D( Surface05, i_PSIn.TexMaterial02 );
	
	float4 Color = (	ColorMaterial00 * Weights.x +
						ColorMaterial01 * Weights.y +
						ColorMaterial02 * Weights.z ) * i_PSIn.Color;
	
	return Color; //* Weights.w;
}

// ================================================================================================
float4 PSBlendMaterialsBlendSet02( PSIn i_PSIn ) : COLOR
{
	float4 Weights = tex2D( BlendMap02, i_PSIn.TexBlend );
	float4 ColorMaterial00 = tex2D( Surface06, i_PSIn.TexMaterial00 );
	float4 ColorMaterial01 = tex2D( Surface07, i_PSIn.TexMaterial01 );
	float4 ColorMaterial02 = tex2D( Surface08, i_PSIn.TexMaterial02 );
	
	float4 Color = (	ColorMaterial00 * Weights.x +
						ColorMaterial01 * Weights.y +
						ColorMaterial02 * Weights.z ) * i_PSIn.Color;
	
	return Color;//* Weights.w;
}

// ================================================================================================
float4 PSBlendMaterialsBlendSet03( PSIn i_PSIn ) : COLOR
{
	float4 Weights = tex2D( BlendMap03, i_PSIn.TexBlend );
	float4 ColorMaterial00 = tex2D( Surface09, i_PSIn.TexMaterial00 );
	float4 ColorMaterial01 = tex2D( Surface10, i_PSIn.TexMaterial01 );
	float4 ColorMaterial02 = tex2D( Surface11, i_PSIn.TexMaterial02 );
	
	float4 Color = (	ColorMaterial00 * Weights.x +
						ColorMaterial01 * Weights.y +
						ColorMaterial02 * Weights.z ) * i_PSIn.Color;
	
	return Color; //* Weights.w;
}

// ================================================================================================
float4 PSBlendMaterialsBlendSet04( PSIn i_PSIn ) : COLOR
{
	float4 Weights = tex2D( BlendMap04, i_PSIn.TexBlend );
	float4 ColorMaterial00 = tex2D( Surface12, i_PSIn.TexMaterial00 );
	float4 ColorMaterial01 = tex2D( Surface13, i_PSIn.TexMaterial01 );
	float4 ColorMaterial02 = tex2D( Surface14, i_PSIn.TexMaterial02 );
	
	float4 Color = (	ColorMaterial00 * Weights.x +
						ColorMaterial01 * Weights.y +
						ColorMaterial02 * Weights.z ) * i_PSIn.Color;
	
	return Color; //* Weights.w;
}

// ================================================================================================
float4 PSBlendMaterialsBlendSet05( PSIn i_PSIn ) : COLOR
{
	float4 Weights = tex2D( BlendMap05, i_PSIn.TexBlend );
	float4 ColorMaterial00 = tex2D( Surface15, i_PSIn.TexMaterial00 );
	float4 ColorMaterial01 = tex2D( Surface16, i_PSIn.TexMaterial01 );
	float4 ColorMaterial02 = tex2D( Surface17, i_PSIn.TexMaterial02 );
	
	float4 Color = (	ColorMaterial00 * Weights.x +
						ColorMaterial01 * Weights.y +
						ColorMaterial02 * Weights.z ) * i_PSIn.Color;
	
	return Color; //* Weights.w;
}

// ================================================================================================
float4 PSBlendMaterialsBlendSet06( PSIn i_PSIn ) : COLOR
{
	float4 Weights = tex2D( BlendMap06, i_PSIn.TexBlend );
	float4 ColorMaterial00 = tex2D( Surface18, i_PSIn.TexMaterial00 );
	float4 ColorMaterial01 = tex2D( Surface19, i_PSIn.TexMaterial01 );
	float4 ColorMaterial02 = tex2D( Surface20, i_PSIn.TexMaterial02 );
	
	float4 Color = (	ColorMaterial00 * Weights.x +
						ColorMaterial01 * Weights.y +
						ColorMaterial02 * Weights.z ) * i_PSIn.Color;
	
	return Color; //* Weights.w;
}

// ================================================================================================
float4 PSBlendMaterialsBlendSet07( PSIn i_PSIn ) : COLOR
{
	float4 Weights = tex2D( BlendMap07, i_PSIn.TexBlend );
	float4 ColorMaterial00 = tex2D( Surface21, i_PSIn.TexMaterial00 );
	float4 ColorMaterial01 = tex2D( Surface22, i_PSIn.TexMaterial01 );
	float4 ColorMaterial02 = tex2D( Surface23, i_PSIn.TexMaterial02 );
	
	float4 Color = (	ColorMaterial00 * Weights.x +
						ColorMaterial01 * Weights.y +
						ColorMaterial02 * Weights.z ) * i_PSIn.Color;
	
	return Color; //* Weights.w;
}

// ================================================================================================
float4 PSBlendMaterialsBlendSet08( PSIn i_PSIn ) : COLOR
{
	float4 Weights = tex2D( BlendMap08, i_PSIn.TexBlend );
	float4 ColorMaterial00 = tex2D( Surface24, i_PSIn.TexMaterial00 );
	float4 ColorMaterial01 = tex2D( Surface25, i_PSIn.TexMaterial01 );
	float4 ColorMaterial02 = tex2D( Surface26, i_PSIn.TexMaterial02 );
	
	float4 Color = (	ColorMaterial00 * Weights.x +
						ColorMaterial01 * Weights.y +
						ColorMaterial02 * Weights.z ) * i_PSIn.Color;
	
	return Color; //* Weights.w;
}

// ================================================================================================
float4 PSBlendMaterialsBlendSet09( PSIn i_PSIn ) : COLOR
{
	float4 Weights = tex2D( BlendMap09, i_PSIn.TexBlend );
	float4 ColorMaterial00 = tex2D( Surface27, i_PSIn.TexMaterial00 );
	float4 ColorMaterial01 = tex2D( Surface28, i_PSIn.TexMaterial01 );
	float4 ColorMaterial02 = tex2D( Surface29, i_PSIn.TexMaterial02 );
	
	float4 Color = (	ColorMaterial00 * Weights.x +
						ColorMaterial01 * Weights.y +
						ColorMaterial02 * Weights.z ) * i_PSIn.Color;
	
	return Color; //* Weights.w;
}



// ================================================================================================
float4 PSBlendSnow( PSIn i_PSIn ) : COLOR
{
	float4 Weight = tex2D( BlendMapSnow, i_PSIn.TexBlend );
	float4 Color = tex2D( Snow, i_PSIn.TexMaterial00 );
	
	Color *= i_PSIn.Color;
	Color.a = Weight.a * min( 1.0f, Color.a + Weight.a);
	
	return Color;
}

// ================================================================================================
float4 PSGrid( PSIn i_PSIn ) : COLOR
{
	return float4( 1.0f, 0.0f, 0.0f, 0.5f );
}

// ================================================================================================
float4 PSBlendFog( PSIn i_PSIn ) : COLOR
{
	// <Artist DeapSea>:
	// edit the first three float values
	// to setup the deep sea color to blend to
	// 0.0f, 0.0f, 1.0f is simple blue
	
	float4 C = FogColor;
	C.w = i_PSIn.Fog.x;
	
	return C;
}



// ================================================================================================
#define RS_Z_ALPHA_SOLID_SET\
	ShadeMode = Gouraud;\
	CullMode = CW;\
	ZEnable = true;\
	ZWriteEnable = true;\
	AlphaTestEnable = false;\
	AlphaBlendEnable = false;
		
#define RS_Z_ALPHA_BLENDED_SET\
	ZEnable = true;\
	ZWriteEnable = true;\
	AlphaBlendEnable = true;\
	DestBlend = One;\
	SrcBlend = One;

#define RS_Z_BLENDED_SNOW\
	ZEnable = true;\
	ZWriteEnable = true;\
	AlphaBlendEnable = true;\
	DestBlend = InvSrcAlpha;\
	SrcBlend = SrcAlpha;
	
#define RS_Z_BLENDED_FOG\
	ZEnable = true;\
	ZWriteEnable = true;\
	AlphaBlendEnable = true;\
	DestBlend = InvSrcAlpha;\
	SrcBlend = SrcAlpha;

#define SETUP_TEXTURE_STAGES\
	TexCoordIndex[0] = 0;\
	TextureTransformFlags[0] = Disable;\
	TexCoordIndex[1] = 1;\
	TextureTransformFlags[1] = Disable;\
	TexCoordIndex[2] = 2;\
	TextureTransformFlags[2] = Disable;\
	TexCoordIndex[3] = 3;\
	TextureTransformFlags[3] = Disable;
	


// ================================================================================================
// techniques
// ================================================================================================
technique GroundTileSingleSet
{
	pass MaterialSet00
	{
		FillMode = <GROUND_FILL_MODE>;
		
		RS_Z_ALPHA_SOLID_SET
		SETUP_TEXTURE_STAGES
		
		// VertexShader = compile SHAD_VS_MINVER_1_1 VSDebug();
		// PixelShader = compile SHAD_PS_MINVER_1_1 PSDebug();
		
		FogColor = <FogColor>;
		
		VertexShader = compile SHAD_VS_MINVER_1_1 VSTransformEnlightenGernerateUV();
		//PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendMaterialsSolidSet();
		PixelShader = compile SHAD_PS_MINVER_1_1 PSDebug();
	}
	
	pass BlendSnow
	{
		RS_Z_BLENDED_SNOW
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendSnow();
	}
	
	pass BlendFog
	{
		RS_Z_BLENDED_FOG
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendFog();
	}
	
	/*
	pass Grid
	{
		FillMode = WireFrame;
		AlphaBlendEnable = true;
		ZEnable = true;
		
		PixelShader = compile SHAD_PS_MINVER_1_1 PSGrid();
	}
	*/
}

// ================================================================================================
technique GroundTileDoubleSet
{
	pass MaterialSet00
	{
		FillMode = <GROUND_FILL_MODE>;
		
		RS_Z_ALPHA_SOLID_SET
		SETUP_TEXTURE_STAGES
		
		VertexShader = compile SHAD_VS_MINVER_1_1 VSTransformEnlightenGernerateUV();
		PixelShader = compile SHAD_PS_MINVER_1_1 PSDebug();
		//PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendMaterialsSolidSet();
		
	}	
	
	pass MaterialSet01
	{
		RS_Z_ALPHA_BLENDED_SET
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendMaterialsBlendSet01();
	}
	
	pass BlendSnow
	{
		RS_Z_BLENDED_SNOW
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendSnow();
	}
	
	pass BlendFog
	{
		RS_Z_BLENDED_FOG
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendFog();
	}
}

// ================================================================================================
technique GroundTileTrippleSet
{
	pass MaterialSet00
	{
		FillMode = <GROUND_FILL_MODE>;
			
		RS_Z_ALPHA_SOLID_SET
		SETUP_TEXTURE_STAGES
		
		VertexShader = compile SHAD_VS_MINVER_1_1 VSTransformEnlightenGernerateUV();
		PixelShader = compile SHAD_PS_MINVER_1_1 PSDebug();
		//PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendMaterialsSolidSet();
	}	
	
	pass MaterialSet01
	{
		RS_Z_ALPHA_BLENDED_SET
			
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendMaterialsBlendSet01();
	}
	
	pass MaterialSet02
	{
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendMaterialsBlendSet02();
	}
	
	pass BlendSnow
	{
		RS_Z_BLENDED_SNOW
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendSnow();
	}
	
	pass BlendFog
	{
		RS_Z_BLENDED_FOG
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendFog();
	}
}

// ================================================================================================
technique GroundTileQuadSet
{
	pass MaterialSet00
	{
		FillMode = <GROUND_FILL_MODE>;
			
		RS_Z_ALPHA_SOLID_SET
		SETUP_TEXTURE_STAGES
	
		VertexShader = compile SHAD_VS_MINVER_1_1 VSTransformEnlightenGernerateUV();
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendMaterialsSolidSet();
		// PixelShader = compile SHAD_PS_MINVER_1_1 PSRednerBlendSet03();
	}	
	
	pass MaterialSet01
	{
		RS_Z_ALPHA_BLENDED_SET
			
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendMaterialsBlendSet01();
	}
	
	pass MaterialSet02
	{
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendMaterialsBlendSet02();
	}
	
	pass MaterialSet03
	{
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendMaterialsBlendSet03();
	}
	
	pass BlendSnow
	{
		RS_Z_BLENDED_SNOW
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendSnow();
	}
	
	pass BlendFog
	{
		RS_Z_BLENDED_FOG
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendFog();
	}
}

// ================================================================================================
technique GroundTileQuintSet
{
	pass MaterialSet00
	{
		FillMode = <GROUND_FILL_MODE>;
			
		RS_Z_ALPHA_SOLID_SET
		SETUP_TEXTURE_STAGES
	
		VertexShader = compile SHAD_VS_MINVER_1_1 VSTransformEnlightenGernerateUV();
		PixelShader = compile SHAD_PS_MINVER_1_1 PSDebug();
		//PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendMaterialsSolidSet();
	}	
	
	pass MaterialSet01
	{
		RS_Z_ALPHA_BLENDED_SET
				
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendMaterialsBlendSet01();
	}
	
	pass MaterialSet02
	{
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendMaterialsBlendSet02();
	}
	
	pass MaterialSet03
	{
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendMaterialsBlendSet03();
	}
	
	pass MaterialSet04
	{
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendMaterialsBlendSet04();
	}
	
	pass BlendSnow
	{
		RS_Z_BLENDED_SNOW
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendSnow();
	}
	
	pass BlendFog
	{
		RS_Z_BLENDED_FOG
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendFog();
	}
}

// ================================================================================================
technique GroundTileSextSet
{
	pass MaterialSet00
	{
		FillMode = <GROUND_FILL_MODE>;
			
		RS_Z_ALPHA_SOLID_SET
		SETUP_TEXTURE_STAGES
	
		VertexShader = compile SHAD_VS_MINVER_1_1 VSTransformEnlightenGernerateUV();
		PixelShader = compile SHAD_PS_MINVER_1_1 PSDebug();
		//PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendMaterialsSolidSet();
	}	
	
	pass MaterialSet01
	{
		RS_Z_ALPHA_BLENDED_SET
				
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendMaterialsBlendSet01();
	}
	
	pass MaterialSet02
	{
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendMaterialsBlendSet02();
	}
	
	pass MaterialSet03
	{
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendMaterialsBlendSet03();
	}
	
	pass MaterialSet04
	{
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendMaterialsBlendSet04();
	}
	
	pass MaterialSet05
	{
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendMaterialsBlendSet05();
	}
	
	pass BlendSnow
	{
		RS_Z_BLENDED_SNOW
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendSnow();
	}
	
	pass BlendFog
	{
		RS_Z_BLENDED_FOG
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendFog();
	}
}

// ================================================================================================
technique GroundTileSeptSet
{
	pass MaterialSet00
	{
		FillMode = <GROUND_FILL_MODE>;
			
		RS_Z_ALPHA_SOLID_SET
		SETUP_TEXTURE_STAGES
	
		VertexShader = compile SHAD_VS_MINVER_1_1 VSTransformEnlightenGernerateUV();
		PixelShader = compile SHAD_PS_MINVER_1_1 PSDebug();
		//PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendMaterialsSolidSet();
	}	
	
	pass MaterialSet01
	{
		RS_Z_ALPHA_BLENDED_SET
				
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendMaterialsBlendSet01();
	}
	
	pass MaterialSet02
	{
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendMaterialsBlendSet02();
	}
	
	pass MaterialSet03
	{
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendMaterialsBlendSet03();
	}
	
	pass MaterialSet04
	{
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendMaterialsBlendSet04();
	}
	
	pass MaterialSet05
	{
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendMaterialsBlendSet05();
	}
	
	pass MaterialSet06
	{
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendMaterialsBlendSet06();
	}
	
	pass BlendSnow
	{
		RS_Z_BLENDED_SNOW
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendSnow();
	}
	
	pass BlendFog
	{
		RS_Z_BLENDED_FOG
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendFog();
	}
}

// ================================================================================================
technique GroundTileOctSet
{
	pass MaterialSet00
	{
		FillMode = <GROUND_FILL_MODE>;
			
		RS_Z_ALPHA_SOLID_SET
		SETUP_TEXTURE_STAGES
	
		VertexShader = compile SHAD_VS_MINVER_1_1 VSTransformEnlightenGernerateUV();
		PixelShader = compile SHAD_PS_MINVER_1_1 PSDebug();
		//PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendMaterialsSolidSet();
	}	
	
	pass MaterialSet01
	{
		RS_Z_ALPHA_BLENDED_SET
				
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendMaterialsBlendSet01();
	}
	
	pass MaterialSet02
	{
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendMaterialsBlendSet02();
	}
	
	pass MaterialSet03
	{
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendMaterialsBlendSet03();
	}
	
	pass MaterialSet04
	{
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendMaterialsBlendSet04();
	}
	
	pass MaterialSet05
	{
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendMaterialsBlendSet05();
	}
	
	pass MaterialSet06
	{
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendMaterialsBlendSet06();
	}
	
	pass MaterialSet07
	{
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendMaterialsBlendSet07();
	}
	
	pass BlendSnow
	{
		RS_Z_BLENDED_SNOW
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendSnow();
	}
	
	pass BlendFog
	{
		RS_Z_BLENDED_FOG
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendFog();
	}
}

// ================================================================================================
technique GroundTileNonSet
{
	pass MaterialSet00
	{
		FillMode = <GROUND_FILL_MODE>;
			
		RS_Z_ALPHA_SOLID_SET
		SETUP_TEXTURE_STAGES
	
		VertexShader = compile SHAD_VS_MINVER_1_1 VSTransformEnlightenGernerateUV();
		PixelShader = compile SHAD_PS_MINVER_1_1 PSDebug();
		//PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendMaterialsSolidSet();
	}	
	
	pass MaterialSet01
	{
		RS_Z_ALPHA_BLENDED_SET
				
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendMaterialsBlendSet01();
	}
	
	pass MaterialSet02
	{
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendMaterialsBlendSet02();
	}
	
	pass MaterialSet03
	{
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendMaterialsBlendSet03();
	}
	
	pass MaterialSet04
	{
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendMaterialsBlendSet04();
	}
	
	pass MaterialSet05
	{
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendMaterialsBlendSet05();
	}
	
	pass MaterialSet06
	{
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendMaterialsBlendSet06();
	}
	
	pass MaterialSet07
	{
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendMaterialsBlendSet07();
	}
	
	pass MaterialSet08
	{
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendMaterialsBlendSet08();
	}
	
	pass BlendSnow
	{
		RS_Z_BLENDED_SNOW
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendSnow();
	}
	
	pass BlendFog
	{
		RS_Z_BLENDED_FOG
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendFog();
	}
}

// ================================================================================================
technique GroundTileDecSet
{
	pass MaterialSet00
	{
		FillMode = <GROUND_FILL_MODE>;
			
		RS_Z_ALPHA_SOLID_SET
		SETUP_TEXTURE_STAGES
	
		VertexShader = compile SHAD_VS_MINVER_1_1 VSTransformEnlightenGernerateUV();
		PixelShader = compile SHAD_PS_MINVER_1_1 PSDebug();
		//PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendMaterialsSolidSet();
	}	
	
	pass MaterialSet01
	{
		RS_Z_ALPHA_BLENDED_SET
				
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendMaterialsBlendSet01();
	}
	
	pass MaterialSet02
	{
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendMaterialsBlendSet02();
	}
	
	pass MaterialSet03
	{
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendMaterialsBlendSet03();
	}
	
	pass MaterialSet04
	{
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendMaterialsBlendSet04();
	}
	
	pass MaterialSet05
	{
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendMaterialsBlendSet05();
	}
	
	pass MaterialSet06
	{
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendMaterialsBlendSet06();
	}
	
	pass MaterialSet07
	{
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendMaterialsBlendSet07();
	}
	
	pass MaterialSet08
	{
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendMaterialsBlendSet08();
	}
	
	pass MaterialSet09
	{
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendMaterialsBlendSet09();
	}
	
	pass BlendSnow
	{
		RS_Z_BLENDED_SNOW
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendSnow();
	}
	
	pass BlendFog
	{
		RS_Z_BLENDED_FOG
		PixelShader = compile SHAD_PS_MINVER_1_1 PSBlendFog();
	}
}
